/*
*	ExMobi4.x+ JS
*	Version	: 1.0.0
*	Author	: Domo
*	Email	:
*	Weibo	:
*	Copyright 2015 (c)
*/

/**
 *通用类 可在uixml、xhtml、html5中运行
 */
var Family = (function() {

	/**
	 *进度条提示
	 */
	var _processBar = {
		process : null,
		Show : function(msg, isBlock) {
			msg = msg || ""
			_processBar.process = _processBar.process ? _processBar.process : (new ProgressBar());
			_processBar.process.setMessage(msg)
			_processBar.process.show(isBlock || false);
		},
		Hide : function() {
			_processBar.process && _processBar.process.cancel();
		}
	}

	/***
	 *操作提示
	 */
	var _toast = {
		Show : function(text, duration, style) {
			duration = duration || 2000;
			var toast = new Toast();
			toast.setText(text || "");
			toast.setDuration(duration);
			style && toast.setStyle(style);
			toast.show();
		},
		Error : function(text, duration, style) {
			_toast.Show(text, duration, (style || "background-color:#eb4f38;color:white;border-color:#eb4f38"));
		}
	}

	/**
	 *JS生成Guid
	 */
	var _newId = function() {
		var S4 = function() {
			return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
		};
		return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
	}
	/**
	 * 获取当前网络连接状态
	 * 返回true，表示有可用网络连接
	 * 返回false，表示没有可用网络连接
	 */
	var _netConnectState = function() {
		return NetworkUtil.getConnectState();
	}
	/**
	 *普通请求
	 * @param {Object} option
	 * 请求参数 JSON格式
	 * {url:"",data:"",success:function(){},fail:function(){},isBlock:true,timeout:"",onComplete:function(){}}
	 */
	var _doRequest = function(option) {

		if (!_netConnectState()) {
			_toast.Error("无网络连接,请检查您的网络设置");
			return;
		}
		option.onComplete && option.onComplete();
		var request = {
			url : option.url,
			method : "POST",
			data : encodeURI(option.data),
			timeout : (option.timeOut || 1 * 30 ) * 1000,
			successFunction : "_ajax_success_",
			failFunction : "_ajax_fail_",
			isBlock : (option.isBlock || false)
		}
		var direct = new DirectAjax(request);
		direct.setArrayData("_ajax_callback_", [option.success, option.fail])
		direct.send();

	}
	/**
	 *带附件上传的请求
	 * @param {Object} option
	 * 请求参数 JSON格式
	 * {url:"",data:"",success:function(){},fail:function(){},isBlock:true,timeout:"",onComplete:function(){}}
	 */
	var _doFormRequest = function(option) {
		if (!_netConnectState()) {
			_toast.Error("无网络连接,请检查您的网络设置");
			return;
		}
		option.onComplete && option.onComplete();
		var request = {
			url : option.url,
			data : option.data,
			method : "POST",
			successFunction : "_ajax_success_",
			failFunction : "_ajax_fail_",
			reqCharset : "utf-8",
			isBlock : (option.isBlock || false),
			timeout : (option.timeOut || 1 * 30) * 1000
		};
		var ajax = new DirectFormSubmit(request);
		direct.setArrayData("_ajax_callback_", [option.success, option.fail])
		ajax.send();
	}
	/**
	 *二维码解析
	 */
	var _decode = function(fn) {
		if (!fn) {
			return;
		}
		var decode = new Decode();
		var callback = function() {
			if (!decode.isSuccess()) {
				_toast.Show("解码失败");
				return;
			}
			fn && fn(decode.result);
		}
		decode.onCallback = callback;
		decode.startDecode();

	}
	/**
	 *调用系统相册
	 * @param {Object} option 参数为JSON格式
	 * {pwidth:0,maxnums:5,callback:function(){}}
	 */
	var _imageChoice = function(option) {
		var imageChoice = new ImageChoice();

		var callback = function(selectPaths) {
			option.callback && option.callback(selectPaths);
		}
		if (option.pwidth) {
			imageChoice.pwidth = option.pwidth;
		}

		if (option.maxnums) {
			imageChoice.nums = option.maxnums;
		}
		imageChoice.onCallback = callback;
		imageChoice.start();
	}

	return {
		DoRequest : _doRequest, //普通请求
		DoFormRequest : _doFormRequest, //带附件上传的请求
		ProcessBar : _processBar, //进度条
		Toast : _toast, //提示信息
		NewId : _newId, //JS生成Guid
		NetConnectState : _netConnectState, //网络连接状态
		Decode : _decode, //二维码解析
		ImageChoice : _imageChoice//调用系统相册
	};
})();

var _ajax_success_ = function(ajax) {
	var success = ajax.getArrayData("_ajax_callback_")[0]
	success && eval(success)(ajax);
};
var _ajax_fail_ = function(ajax) {
	var fail = ajax.getArrayData("_ajax_callback_")[1]
	fail && eval(fail)(ajax);
};

